//+------------------------------------------------------------------+
//|                                                    Color_RSI.mq5 |
//+------------------------------------------------------------------+

//   .
#property copyright "TheXpert"
#property link      "theforexpert@gmail.com"

#property version   "1.00"

//   --     511 
//     
#property description "      "
#property description "  "
#property description "   RSI"

//   
#property indicator_separate_window //      

//#property indicator_minimum 0
//#property indicator_maximum 100

#property indicator_buffers 4       //   
#property indicator_plots 2         //   

#property indicator_color1 DarkSalmon, DeepSkyBlue //  2 
#property indicator_type1 DRAW_COLOR_LINE          //     

#property indicator_color2 DarkSalmon, DeepSkyBlue //  2 
#property indicator_type2 DRAW_COLOR_LINE          //     

//---- buffers
double Values[];                    //  
double ValuesPainting[];            //   
double SmoothedValues[];            //   
double SmoothedValuesPainting[];    //   
double BufferForCopy[];

//   
input string               _1             = "  RSI";
input int                  RSIPeriod      = 5;
input int                  SmoothPeriod   = 5;
input ENUM_APPLIED_PRICE   AppliedPrice   = PRICE_CLOSE;
input string               _2             = " ";
input color                Down           = DarkSalmon;
input color                Up             = DeepSkyBlue;

// ,      
int RSIHandle;
int SmoothHandle;

//   
int OnInit()
{
   //   
   // Values    
   SetIndexBuffer(0, Values,                 INDICATOR_DATA);
   // ValuesPainting     
   SetIndexBuffer(1, ValuesPainting,         INDICATOR_COLOR_INDEX);
   
   // Values    
   SetIndexBuffer(2, SmoothedValues,         INDICATOR_DATA);
   // ValuesPainting     
   SetIndexBuffer(3, SmoothedValuesPainting, INDICATOR_COLOR_INDEX);

   //     Values
   PlotIndexSetInteger(0, PLOT_DRAW_BEGIN, RSIPeriod);
   //     Values
   PlotIndexSetInteger(2, PLOT_DRAW_BEGIN, RSIPeriod + SmoothPeriod);
   //   
   IndicatorSetString(INDICATOR_SHORTNAME, " RSI(" + string(RSIPeriod) + "," + string(SmoothPeriod) + ")");
   //      Values
   PlotIndexSetDouble(0, PLOT_EMPTY_VALUE, EMPTY_VALUE);
   PlotIndexSetDouble(2, PLOT_EMPTY_VALUE, EMPTY_VALUE);
   //   
   PlotIndexSetInteger(0, PLOT_LINE_COLOR, 0, Down);
   PlotIndexSetInteger(0, PLOT_LINE_COLOR, 1, Up);
   PlotIndexSetInteger(2, PLOT_LINE_COLOR, 0, Down);
   PlotIndexSetInteger(2, PLOT_LINE_COLOR, 1, Up);

   RSIHandle = iRSI(NULL, 0, RSIPeriod, AppliedPrice);
   SmoothHandle = iMA(NULL, 0, SmoothPeriod, 0, MODE_EMA, RSIHandle);
   
   ArrayResize(BufferForCopy, 3);

   //    
   ArraySetAsSeries(Values, true);
   ArraySetAsSeries(ValuesPainting, true);
   ArraySetAsSeries(SmoothedValues, true);
   ArraySetAsSeries(SmoothedValuesPainting, true);
   ArraySetAsSeries(BufferForCopy, true);

   return(0);
}

//   
//   __ 
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
{
   int toCount = (int)MathMin(rates_total, rates_total - prev_calculated + 1);
   
   // ""  ,      
   if (toCount <= 3)
   {
      int copied = CopyBuffer(RSIHandle, 0, 0, toCount, BufferForCopy);
      if (copied == -1)
      {
         Print("     ", GetLastError());
         return 0;
      }
      
      for (int i = toCount - 1; i >= 0; --i)
      {
         Values[i] = BufferForCopy[i];
      }

      copied = CopyBuffer(SmoothHandle, 0, 0, toCount, BufferForCopy);
      if (copied == -1)
      {
         Print("      ", GetLastError());
         return 0;
      }
      
      for (int i = toCount - 1; i >= 0; --i)
      {
         SmoothedValues[i] = BufferForCopy[i];
      }
   }
   else
   {
      int copied = CopyBuffer(RSIHandle, 0, 0, rates_total, Values);
      if (copied == -1)
      {
         Print("     ", GetLastError());
         return 0;
      }

      copied = CopyBuffer(SmoothHandle, 0, 0, rates_total, SmoothedValues);
      if (copied == -1)
      {
         Print("     ", GetLastError());
         return 0;
      }
   }
   
   // . ,     
   for (int i = toCount - 2; i >= 0; --i)
   {
      
      if (Values[i + 1] != EMPTY_VALUE && 
          Values[i] > Values[i + 1])   ValuesPainting[i] = 1;
      else                             ValuesPainting[i] = 0;

      if (SmoothedValues[i + 1] != EMPTY_VALUE &&
          SmoothedValues[i] > SmoothedValues[i + 1])  SmoothedValuesPainting[i] = 1;
      else                                            SmoothedValuesPainting[i] = 0;
   }

   return rates_total;
}
